/* jshint esversion : 6 */


module.exports = class DynamicItems {
    constructor(pageSize) {
        this.loadedPages = {};

        this.numItems = 0;

        this.PAGE_SIZE = pageSize || 50;

        this.fetchNumItems_();
    }

    getItemAtIndex(index) {
        const pageNumber = Math.floor(index / this.PAGE_SIZE);
        const page = this.loadedPages[pageNumber];

        if (page) {
            return page[index % this.PAGE_SIZE];
        } else if (page !== null) {
            this.fetchPage_(pageNumber);
        }
    }

    getLength() {
        return this.numItems;
    }
};