/* jshint esversion : 6 */
(function formProvider(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){


const FormField = require('./FormField');

function Form(name, opt) {

    const form = {};
    form.name = name;
    const { title, action, method = "post", bindToForm, enableFlashMessage = true } = opt;
    form.title = title;
    form.action = action;
    form.method = method;
    form.request = { url: action, method: method };
    form.bindToForm = bindToForm;
    form.enableFlashMessage = enableFlashMessage;
    const { successRedirect, failureRedirect } = opt;
    form.succesRedirect = successRedirect;
    form.failureRedirect = failureRedirect;
    const { disableClass = "grey", enableClass = "blue" } = opt;
    form.disableClass = disableClass;
    form.enableClass = enableClass;
    const { disableIconClass = "grey-text", enableIconClass = "green-text" } = opt;
    form.disableIconClass = disableIconClass;
    form.enableIconClass = enableIconClass;
    const { errorIconClass = "red-text", validIconClass = "blue-text" } = opt;
    form.errorIconClass = errorIconClass;
    form.validIconClass = validIconClass;
    form.fields = [];
    form._groups = {};
    form.addField = function(name, opt) {
        if (!opt.group)
            opt.group = "group_" + this.fields.length;

        if (!this._groups[opt.group]) {
            this._groups[opt.group] = { fields: [], order: Object.keys(this._groups).length };
        }

        if (this.fields.indexOf(name) === -1) {
            const f = FormField(name, opt)
            this.fields.push(f);
            this._groups[opt.group].fields.push(f);
        }

        return this;
    }.bind(form);



    return form;
}


module.exports = Form;
},{"./FormField":2}],2:[function(require,module,exports){


const genId = function() {
    let text = "";
    let possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 10; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
};

function FormField(name, opt) {
    if (!opt) opt = {};

    const form_field = {};
    form_field.name = name;
    const {
        value = "", type = "text", required = false, label = null, icon = null, group, flex, flexOffset, autocomplete = false, id = genId()
    } = opt;
    form_field.value = value;
    form_field.type = type;
    form_field.required = required;
    form_field.error = {};
    form_field.label = label;
    form_field.icon = icon;
    form_field.group = group;
    form_field.flex = flex;
    form_field.flex_offset = flexOffset;
    form_field.autocomplete = autocomplete;
    form_field.id = id;
    const mq = [
        '-xs', '-gt-xs',
        '-sm', '-gt-sm',
        '-md', '-gt-md',
        '-lg', '-gt-lg', '-xl'
    ];
    mq.map(e => 'flex' + e).forEach(v => form_field[v] = opt[v.replace(/\-/g, '_')] || flex);
    mq.map(e => 'flex_offset' + e).forEach(v => form_field[v] = opt[v.replace(/\-/g, '_')] || flexOffset);
    form_field.validation = (function({ validation, type }) {
        const r = {};

        if (!validation || (type && type === 'number'))
            return "none";
        else if ("string" === typeof validation || RegExp === validation.constructor)
            r.pattern = validation;

        Object.entries(validation).forEach(e => {
            const [k, v] = e;
            r[k] = v;
        });

        return r;
    }(opt));
    form_field.regExp = (function(v) {
        if (v !== 'none')
            return ("string" === typeof v.pattern ? (v.flags ? new RegExp(v.pattern, v.flags) : new RegExp(v.pattern)) : v.pattern);
        else
            return null;
    }(form_field.validation));
    Object.defineProperty(form_field, 'validPattern', {
        get: function() {
            this.error.pattern = false;

            if (this.validation === 'none')
                return true;
            else if (this.value != null && "undefined" !== typeof this.value && this.value.toString().length) {
                this.error.pattern = !this.regExp.test(this.value);
                return !this.error.pattern;
            } else
                return true;
        }
    });
    Object.defineProperty(form_field, 'requiredEditing', {
        get: function() {
            if (this.required && this.value != null && "undefined" !== typeof this.value) {
                this.error.required = this.value.toString().length === 0;
            } else
                this.error.required = false;

            return !this.error.required;
        }
    });
    Object.defineProperty(form_field, 'valid', {
        get: function() {
            return (this.validPattern && this.requiredEditing);
        }
    });
    Object.defineProperty(form_field, '$error', {
        get: function() {
            const a = {};

            const valid = this.valid;

            if (this.value != null && 'undefined' !== typeof this.value && this.value.toString().length)
                this.class = valid ? 'valid' : 'not-valid';

            for (let k in this.error) {
                if (this.error[k]) {
                    a[k] = !valid;
                    if (!valid)
                        this.error[k] = false;
                } else
                    continue;
            }

            return a;
        }
    });


    return form_field;
}

module.exports = FormField;
},{}],3:[function(require,module,exports){


const angular_module = require('./module');
const Form = require('./Form');

const forms = {};
const FormProvider = {
    addForm(name, opt, fn) {

        if (!forms.hasOwnProperty(name))
            forms[name] = Form(name, opt);

        if (fn)
            fn.call(this, forms[name]);

        return this;
    },
    $get($http, $timeout, $location) {
        return name => {


            let flashMessage = null,
                flashMessageCod = null;

            const m = class {
                constructor(name) {
                    angular.extend(this, forms[name]);
                }

                get flashMessage() {
                    return flashMessage;
                }

                get groups() {
                    return Object.values(this._groups).map(e => e.fields)
                }


                sendHttpRequest(fn) {
                    const { request: req, fields } = this;

                    req.data = {};
                    angular.forEach(fields, ({ name, value }, k) => req.data[name] = value);
                    req.transformResponse = (data, headersGetter, status) => {
                        let r;
                        try {
                            r = JSON.parse(data);
                        } catch (e) {
                            r = data;
                        }
                        return r;
                    };

                    if (!fn) {

                        const __locationAssign = (path) => {
                            const a = [
                                ($location.protocol() + '://'), ($location.host() + ':'), $location.port(), (path.match(/^\//) ? path : ('/' + path))
                            ].join("");

                            window.location.assign(a);
                        };


                        const exec = ({ data, status }) => {
                            const { data: res, error, locationRedirect, urlRedirect, hrefRedirect } = data;

                            flashMessage = error ? error : (typeof res === "string" ? res : null);

                            const { failureRedirect, successRedirect } = this;

                            $timeout(() => {
                                if (hrefRedirect) {
                                    window.location.href = hrefRedirect;
                                }
                                if (urlRedirect) {
                                    __locationAssign(urlRedirect);
                                } else if (locationRedirect || failureRedirect || successRedirect) {
                                    if (locationRedirect)
                                        $location.path(locationRedirect);
                                    else
                                        $location.path(error ? failureRedirect : successRedirect);
                                }
                            }, 800, true);

                        };
                        $http(req).then(exec, exec).catch(angular.noop);
                    } else if (typeof fn === "function")
                        $http(req).then(fn, fn).catch(angular.noop);

                }


                get requirementsCompleted() {
                    let r = 1;

                    for (let i = 0; i < this.fields.length; i++) {

                        const { value: v, required } = this.fields[i];

                        if (!required || v !== null && typeof v !== "undefined" && v.toString().length)
                            continue;
                        else {
                            r = 0;
                            break;
                        }
                    }

                    return r;
                }


                get fullyValidated() {
                    let r = 1;
                    for (let i = 0; i < this.fields.length; i++) {
                        if (this.fields[i].valid)
                            continue;
                        else {
                            r = 0;
                            break;
                        }
                    }
                    return r;
                }


                get valid() {
                    return (this.requirementsCompleted && this.fullyValidated);
                }

            };
            return new m(name);
        };
    }
};
angular_module.provider('appForm', FormProvider);
},{"./Form":1,"./module":5}],4:[function(require,module,exports){


require('./module');
require('./FormField');
require('./Form');
require('./FormProvider');
require('./view');
},{"./Form":1,"./FormField":2,"./FormProvider":3,"./module":5,"./view":6}],5:[function(require,module,exports){


module.exports = angular.module('app_form', []);
},{}],6:[function(require,module,exports){


const angular_module = require('./module');

angular_module.directive('appFormAuthInput', () => {
    return {
        restrict: 'A',
        require: ['^^appFormAuthentication', 'ngModel']
    };
});

angular_module.directive('appFormBtn', () => {
    return {
        restrict: 'A',
        require: '^^appFormAuthentication',
        template: '<ng-transclude></ng-transclude>',
        transclude: true,
        scope: {
            sendHttpRequest: '&',
            getFields: '&',
            getFieldsValue: '&'
        },
        link: ($scope, elem, attrs, ctrl) => {

            const { sendHttpRequest, getFields, getFieldsValue } = $scope;

            if (sendHttpRequest) {
                elem.on('click', () => ctrl.sendHttpRequest(sendHttpRequest));
            } else if (getFields) {
                elem.on('click', () => getFields(ctrl.fields));
            } else if (getFieldsValue) {
                elem.on('click', () => getFieldsValue(Object.values(ctrl.fields).map(e => e.value)));
            }
        }
    };
});

angular_module.directive('appFormAuthentication', $timeout => {
    return {
        restrict: 'E',
        controller: ($scope, appForm) => appForm($scope.name),
        controllerAs: '$form',
        scope: {
            name: '@',
            btnTxt: '@?',
            action: '@?',
            method: '@?',
        },
        template: template(),
        transclude: {
            appFormBtn: '?appFormBtn'
        },
        link: (scope, elem, attrs, ctrl) => {

            const form = elem.find('form');

            angular.element(window).on('keyup', ev => {
                if (ev.keyCode === 13 && ctrl.fullyValidated)
                    ctrl.sendHttpRequest();
            });

            if (ctrl.bindToForm) {
                $timeout(() => {
                    form.attr('METHOD', ctrl.method);
                    form.attr('ACTION', ctrl.action);
                }, 0, true);
            }

        }
    };
});


function template() {

    const mq = [
        '-xs', '-gt-xs',
        '-sm', '-gt-sm',
        '-md', '-gt-md',
        '-lg', '-gt-lg', '-xl'
    ];

    let mdInputContainer = '<md-input-container ng-repeat="(k, field) in groups"  flex="{{field.flex}}" flex-offset="{{field.flex_offset}}" ';

    mq.map(e => 'flex' + e).forEach(v => {
        mdInputContainer += v + '="{{field[\'' + v + '\']}}" ';
    });
    mq.map(e => 'flex_offset' + e).forEach(v => {
        mdInputContainer += v + '="{{field[\'' + v + '\']}}" ';
    });

    mdInputContainer += '>';


    return '' +
        '<div layout="row" flex="grow" layout-align="center center">' +
        '   <md-content layout-padding flex>' +
        '       <h1 ng-if="$form.title">{{$form.title}}</h1>' +
        '       <form name="name" layout="column" flex>' +
        '           <div ng-repeat="groups in $form.groups" flex="none" layout="row">' + mdInputContainer +
        '                   <label ng-class="field.class === \'valid\' ? $form.validIconClass : field.class === \'not-valid\' ? $form.errorIconClass : \'\'">{{field.label || field.name}}</label>' +
        '                   <md-icon ng-if="field.icon" ng-bind="field.icon" ng-class="field.class === \'valid\' ? $form.validIconClass : field.class === \'not-valid\' ? $form.errorIconClass : \'\'"></md-icon>' +
        '                   <input app-form-auth-input ng-class="field.class" autocomplete="{{field.autocomplete}}" id="{{field.id}}" type="{{field.type}}" name="{{field.name}}" ng-required="{{field.required}}" ng-model="field.value">' + '</ng-repeat>' +
        '                   <div ng-messages="field.$error" ng-hide="false">' +
        '                       <div ng-message="pattern">{{field.validation.message || \'not valid\'}}</div>' +
        '                   </div>' +
        '               </md-input-container>' +
        '           </div>' +
        '           <div layout="row" flex="none" layout-padding>' +
        '               <div flex="80" ng-if="$form.enableFlashMessage" layout="row">' +
        '                   <div flex layout="row" layout-align="start center" ng-show="$form.flashMessage">' +
        '                       <md-icon ng-bind="\'sentiment_neutral\'"></md-icon>' +
        '                       <div flex="80" layout="row">' +
        '                           <span>{{$form.flashMessage}}</span>' +
        '                       </div>' +
        '                   </div>' +
        '               </div>' +
        '               <div flex="{{$form.enableFlashMessage ? \'20\' : \'auto\'}}" layout="row" layout-align="end center" ng-transclude="appFormBtn">' +
        '                   <md-button ng-if="!$form.bindToForm" aria-label="{{field.name}}" class="md-fab" ng-click="$form.sendHttpRequest()" ng-disabled="!$form.valid" ng-class="!$form.valid ? $form.disableClass : $form.enableClass">' +
        '                       <md-icon ng-bind="\'send\'" ng-class="!$form.valid ? $form.disableIconClass : $form.enableIconClass"></md-icon>' +
        '                   </md-button>' +
        '                   <button type="submit" ng-if="$form.bindToForm" class="md-button md-icon-button" ng-disabled="!$form.valid" ng-class="!$form.valid ? $form.disableClass : $form.enableClass">' +
        '                       <md-icon ng-bind="\'send\'"  ng-class="!$form.valid ? $form.disableIconClass : $form.enableIconClass"></md-icon>' +
        '                   </button>' +
        '               </div>' +
        '           </div>' +
        '       </form>' +
        '   </md-content>' +
        '</div>';
}
},{"./module":5}]},{},[4]);


}());