/* jshint esversion : 6 */

const FormField = require('./FormField');

function Form(name, opt) {

    const form = {};
    form.name = name;
    const { title, action, method = "post", bindToForm, enableFlashMessage = true } = opt;
    form.title = title;
    form.action = action;
    form.method = method;
    form.request = { url: action, method: method };
    form.bindToForm = bindToForm;
    form.enableFlashMessage = enableFlashMessage;
    const { successRedirect, failureRedirect } = opt;
    form.succesRedirect = successRedirect;
    form.failureRedirect = failureRedirect;
    const { disableClass = "grey", enableClass = "blue" } = opt;
    form.disableClass = disableClass;
    form.enableClass = enableClass;
    const { disableIconClass = "grey-text", enableIconClass = "green-text" } = opt;
    form.disableIconClass = disableIconClass;
    form.enableIconClass = enableIconClass;
    const { errorIconClass = "red-text", validIconClass = "blue-text" } = opt;
    form.errorIconClass = errorIconClass;
    form.validIconClass = validIconClass;
    form.fields = [];
    form._groups = {};
    form.addField = function(name, opt) {
        if (!opt.group)
            opt.group = "group_" + this.fields.length;

        if (!this._groups[opt.group]) {
            this._groups[opt.group] = { fields: [], order: Object.keys(this._groups).length };
        }

        if (this.fields.indexOf(name) === -1) {
            const f = FormField(name, opt)
            this.fields.push(f);
            this._groups[opt.group].fields.push(f);
        }

        return this;
    }.bind(form);



    return form;
}


module.exports = Form;