/* jshint esversion : 6 */
(function fullTextSearch(){

    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){



module.exports = (a, size, preserveKey) => {

    const l = a.length;
    const diff = l % size;
    const steps = diff ? ((l - diff) / size + 1) : (l / size);


    const _newArray = new Array(steps);

    for (let i = 0; i < steps; i++)
        _newArray[i] = new Array(
            (diff && i === (steps - 1)) ? diff : size
        );


    let check = 0;
    let step = 0;
    for (let i = 0; i < l; i++) {
        _newArray[step][preserveKey ? i : check] = a[i];
        (check < size - 1) ? check++ : (check = 0, step++);
    }

    return _newArray;

};
},{}],2:[function(require,module,exports){


const angular_module = require('./module');
const array_chunk = require('./array_chunk');


class SearchInterval {
    constructor() {
        this.interval = 0;
        this._fn = null;
    }

    set fn(fn) {
        this._fn = fn;
    }

    get fn() {
        return this._fn;
    }

    clearInterval() {
        const q = $q.defer();
        if (this.fn) {
            try {
                this.interval = 0;
                clearInterval(this._fn);
                delete this._fn;
                q.resolve();
            } catch (e) {
                q.reject(e);
            }
        } else
            q.resolve();

        return q.promise;
    }

    setInterval(txt) {
        const q = $q.defer();

        if (!this.fn) {
            this.fn = setInterval(() => {

                this.interval++;
                const y = this.interval % (txt.split(/\s+/g).length + 1);

                if (!y) {
                    this.clearInterval();
                    q.resolve(txt);
                }
            }, 800);
        } else
            q.reject();

        return q.promise;
    }
}

class SearchWorker extends SearchInterval {
    constructor() {
        super();
        this.worker = null;
    }

    setSearchInterval(txt) {
        return this.setInterval(txt).then(txt => this.setWorker(txt));
    }

    terminateWorker() {
        if (this.worker) {
            this.worker.terminate();
            this.worker = null;
        }
        this.clearInterval();
    }

    setWorker(txt) {
        const q = $q.defer();

        if (!txt || !txt.length) {
            this.terminateWorker();
            q.reject();
        } else {
            if (!this.worker) {
                this.worker = new Worker('fuse/fuse.js');
                q.resolve(txt);
            } else
                q.resolve(txt);
        }

        return q.promise;
    }

    postMessage(a) {
        if (this.worker)
            this.worker.postMessage(a);
    }

    set onmessage(fn) {
        if (this.worker)
            this.worker.onmessage = fn;
    }

}


const FullTextSearch = (data, options) => {


    const __searchWorker = new SearchWorker();

    return (txt, ev) => {
        const q = $q.defer();
        __searchWorker.terminateWorker();

        if (!txt || !txt.length)
            q.resolve(data);

        __searchWorker.setWorker(txt)
            .then(
                txt => {

                    __searchWorker.postMessage({ data, options, txt });

                    __searchWorker.onmessage = ({ data: r }) => {
                        __searchWorker.terminateWorker();

                        if (!r || !r.length)
                            q.reject();
                        else
                            q.resolve(r);
                    };
                },
                () => {
                    q.reject();
                    __searchWorker.terminateWorker();
                }
            )
            .catch(() => {
                q.reject();
                __searchWorker.terminateWorker();
            })
            .done();



        return q.promise;
    };
};



const ChunkSearch = function() {
    return function(data, options) {
        if (!options) options = {};


        const __chunk = array_chunk(data, (options.chunkSize || Math.floor(data.length / 10)));
        const queue = __chunk.map(e => FullTextSearch(e, options));

        return (txt, ev) => {
            const q = $q.defer();

            const z = queue.map(e => e(txt, ev));
            const init = z.shift();

            const x = [];

            $q.allSettled(queue.map(e => e(txt, ev)))
                .then(
                    r => {

                        const x = r.reduce((curr, next) => {
                            if (next.state === 'fulfilled')
                                return curr.concat(next.value);

                            return curr;
                        }, []);



                        if (!x.length)
                            q.reject();
                        else {
                            const a = x[0];
                            const isObject = x => !Array.isArray(x) && typeof x === 'object';

                            if (a != null && isObject(a) && a.hasOwnProperty('item'))
                                q.resolve(x.map(e => e.item));
                            else
                                q.resolve(x);
                        }

                    }, q.reject
                )
                .catch(q.reject)
                .done();



            return q.promise;
        };




    };
};


angular_module.factory('fullTextSearch', ChunkSearch);
},{"./array_chunk":1,"./module":5}],3:[function(require,module,exports){


require('./module');
require('./full_text_search');
require('./modal_search');
},{"./full_text_search":2,"./modal_search":4,"./module":5}],4:[function(require,module,exports){


const angular_module = require('./module');

const __modalTemplate = ({ mdDropDownItems, mdClearButton, mdItemText, mdItemLength, placeholder, mdMenuClass, mdMenuContainerClass, mdItemTemplate, titleField, resultPage }) => {
    return (
        '<form ng-submit="$event.preventDefault()" layout="column">' +
        '   <md-autocomplete ' +
        '  ' + (mdDropDownItems ? 'md-dropdown-items="' + mdDropDownItems + '" ' : '') +
        '       md-clear-button="' + mdClearButton + '" ' +
        '       md-autofocus="true" ' +
        '       id="dialog-full-text-autocomplete"  ' +
        '       md-no-cache="false" ' +
        '       md-selected-item="ctrl.selectedItem" ' +
        '       md-search-text-change="ctrl.textChange(ctrl.searchText)" ' +
        '       md-search-text="ctrl.searchText" ' +
        '       md-selected-item-change="ctrl.selectedItemChange(item)" ' +
        '       md-items="item in ctrl.fullTextSearch(ctrl.searchText)" ' +
        '       md-item-text="item[\'' + mdItemText + '\']" ' +
        '       md-min-length="' + mdItemLength + '" ' +
        '       placeholder="' + placeholder + '" ' +
        '  ' + (mdMenuClass ? 'md-menu-class="' + mdMenuClass + '" ' : '') +
        '       ><md-not-found> Nessun risultato per "{{ctrl.searchText}}"</md-not-found>' +
        '  ' + (mdMenuContainerClass ? 'md-menu-container-class="' + mdMenuContainerClass + '" ' : '') + '>' +
        '       <md-item-template>' + (mdItemTemplate ? mdItemTemplate : titleField ? '<span class="item-title"> {{item[\'' + titleField + '\']}} </span>' : "") + '</md-item-template>' +
        '   </md-autocomplete>' +
        '</form>' + (resultPage || "")
    );
};

const DialogFullTextSearch = function($mdDialog) {
    return function(o) {

        if (!o) o = {};
        const {
            title = "Cerca",
                info = "",
                optTopButton1,
                optTopButton2,
                data,
                fullscreen,
                parent = angular.element(document.body),
                clickOutsideToClose,
                dialogClass,
                locals = {},
                onTextChange,
                onSelectedItemChange,
                resultPage,
                mdItemText,
                mdClearButton = true,
                mdDropDownItems,
                mdItemLength = 0,
                placeholder = "",
                mdMenuClass,
                mdMenuContainerClass,
                titleField,
                mdItemTemplate
        } = o;

        const __template = __modalTemplate({
            resultPage,
            mdItemText,
            mdClearButton,
            mdDropDownItems,
            mdItemLength,
            placeholder,
            mdMenuClass,
            mdMenuContainerClass,
            titleField,
            mdItemTemplate
        });


        return {

            show(ev) {
                $mdDialog.show({
                    controller(fullTextSearch, $compile, $scope, $element) {
                        angular.forEach(locals, (v, k) => this[k] = v);
                        this.fullscreen = fullscreen;
                        this.dialogClass = dialogClass;
                        const _fullTextSearh = fullTextSearch(data);
                        this.fullTextSearch = (txt, ev) => {
                            const q = $q.defer();
                            _fullTextSearh(txt, ev).then(q.resolve, q.reject).catch(q.reject).done();
                            return q.promise;
                        };
                        this.hide = () => $mdDialog.hide();
                        this.cancel = () => $mdDialog.cancel();
                        this.title = title;
                        this.info = info;
                        this.optTopButton1 = optTopButton1;
                        this.optTopButton2 = optTopButton2;
                        this.searchText = "";
                        this.selectedItemChange = item => {
                            this.selectedItem = item;
                            return (onSelectedItemChange ? onSelectedItemChange(item) : angular.noop);
                        };
                        this.textChange = item => onTextChange ? onTextChange(item) : angular.noop;


                        $element.find('md-dialog-content').children().append($compile(__template)($scope));

                    },
                    controllerAs: 'ctrl',
                    templateUrl: 'src/app/views/dialog-full-text-search.html',
                    parent: parent,
                    targetEvent: ev,
                    clickOutsideToClose: clickOutsideToClose,
                    fullscreen: fullscreen
                });
            },
            hide() {
                return $mdDialog.hide();
            },
            cancel() {
                return $mdDialog.cancel();
            }

        };


    };
};

DialogFullTextSearch.$inject = ['$mdDialog'];
angular_module.factory('dialogFullTextSearch', DialogFullTextSearch);
},{"./module":5}],5:[function(require,module,exports){
module.exports = angular.module('fullTextSearch', []);
},{}]},{},[3]);


}());