/* jshint esversion : 6 */

const angular_module = require('./module');

const __modalTemplate = ({ mdDropDownItems, mdClearButton, mdItemText, mdItemLength, placeholder, mdMenuClass, mdMenuContainerClass, mdItemTemplate, titleField, resultPage }) => {
    return (
        '<form ng-submit="$event.preventDefault()" layout="column">' +
        '   <md-autocomplete ' +
        '  ' + (mdDropDownItems ? 'md-dropdown-items="' + mdDropDownItems + '" ' : '') +
        '       md-clear-button="' + mdClearButton + '" ' +
        '       md-autofocus="true" ' +
        '       id="dialog-full-text-autocomplete"  ' +
        '       md-no-cache="false" ' +
        '       md-selected-item="ctrl.selectedItem" ' +
        '       md-search-text-change="ctrl.textChange(ctrl.searchText)" ' +
        '       md-search-text="ctrl.searchText" ' +
        '       md-selected-item-change="ctrl.selectedItemChange(item)" ' +
        '       md-items="item in ctrl.fullTextSearch(ctrl.searchText)" ' +
        '       md-item-text="item[\'' + mdItemText + '\']" ' +
        '       md-min-length="' + mdItemLength + '" ' +
        '       placeholder="' + placeholder + '" ' +
        '  ' + (mdMenuClass ? 'md-menu-class="' + mdMenuClass + '" ' : '') +
        '       ><md-not-found> Nessun risultato per "{{ctrl.searchText}}"</md-not-found>' +
        '  ' + (mdMenuContainerClass ? 'md-menu-container-class="' + mdMenuContainerClass + '" ' : '') + '>' +
        '       <md-item-template>' + (mdItemTemplate ? mdItemTemplate : titleField ? '<span class="item-title"> {{item[\'' + titleField + '\']}} </span>' : "") + '</md-item-template>' +
        '   </md-autocomplete>' +
        '</form>' + (resultPage || "")
    );
};

const DialogFullTextSearch = function($mdDialog) {
    return function(o) {

        if (!o) o = {};
        const {
            title = "Cerca",
                info = "",
                optTopButton1,
                optTopButton2,
                data,
                fullscreen,
                parent = angular.element(document.body),
                clickOutsideToClose,
                dialogClass,
                locals = {},
                onTextChange,
                onSelectedItemChange,
                //
                resultPage,
                mdItemText,
                mdClearButton = true,
                mdDropDownItems,
                mdItemLength = 0,
                placeholder = "",
                mdMenuClass,
                mdMenuContainerClass,
                titleField,
                mdItemTemplate
        } = o;

        const __template = __modalTemplate({
            resultPage,
            mdItemText,
            mdClearButton,
            mdDropDownItems,
            mdItemLength,
            placeholder,
            mdMenuClass,
            mdMenuContainerClass,
            titleField,
            mdItemTemplate
        });


        return {

            show(ev) {
                $mdDialog.show({
                    controller(fullTextSearch, $compile, $scope, $element) {
                        angular.forEach(locals, (v, k) => this[k] = v);
                        this.fullscreen = fullscreen;
                        this.dialogClass = dialogClass;
                        const _fullTextSearh = fullTextSearch(data);
                        this.fullTextSearch = (txt, ev) => {
                            const q = $q.defer();
                            _fullTextSearh(txt, ev).then(q.resolve, q.reject).catch(q.reject).done();
                            return q.promise;
                        };
                        this.hide = () => $mdDialog.hide();
                        this.cancel = () => $mdDialog.cancel();
                        this.title = title;
                        this.info = info;
                        this.optTopButton1 = optTopButton1;
                        this.optTopButton2 = optTopButton2;
                        this.searchText = "";
                        this.selectedItemChange = item => {
                            this.selectedItem = item;
                            return (onSelectedItemChange ? onSelectedItemChange(item) : angular.noop);
                        };
                        this.textChange = item => onTextChange ? onTextChange(item) : angular.noop;


                        $element.find('md-dialog-content').children().append($compile(__template)($scope));

                    },
                    controllerAs: 'ctrl',
                    templateUrl: 'src/app/views/dialog-full-text-search.html',
                    parent: parent,
                    targetEvent: ev,
                    clickOutsideToClose: clickOutsideToClose,
                    fullscreen: fullscreen
                });
            },
            hide() {
                return $mdDialog.hide();
            },
            cancel() {
                return $mdDialog.cancel();
            }

        };


    };
};

DialogFullTextSearch.$inject = ['$mdDialog'];
angular_module.factory('dialogFullTextSearch', DialogFullTextSearch);