/* jshint esversion : 6 */

const angular_module = require('./module');

const config = {};
const ready = $q.defer();

const $IDB = {
    get ready() { return ready.promise; },

    setDb(dbName, opt) {
        config[dbName] = opt;
        return this;
    },

    run() {

        const setDb = (dbName, opt) => () => $appIDB.setDb(dbName, opt);

        const x = Object.entries(config);
        const [kInit, vInit] = x.shift();

        x.reduce(
                (curr, [k, v], index) => {
                    return curr.then(() => setDb(k, v));
                },
                setDb(kInit, vInit)
            )
            .then(ready.resolve, ready.reject, ready.notify)
            .catch(ready.reject)
            .done();




        return ready.promise;
    },

    useDb(dbName) { return $appIDB.useDb(dbName); },

    $get() { return this; }
};
angular_module.provider('$idb', $IDB);